#!/bin/zsh

print_tree_from(){
	local dir=$1
	local depth=$2
	local HIGHLIGHTED_PATH=$3
	# echo dir=$dir $0
	local folders=($(find $dir -type d -d 1))
	folders=($(echo $folders | xargs -n1 | sort | xargs))
	# echo sorted folders are... $folders
	if [ ${#folders} -eq 0 ]
	then
		return 0
	fi

	for folder in $folders
	do
		local dirname=$(echo $folder | sed -E "s/.*(\/[0-9][0-9][0-9])/\1/g")
		# echo dirname=$dirname
		if [[ $dirname =~ "[0-9][0-9][0-9]$" ]]; then
			local spaces=0
			while [ $spaces -lt $depth ]
			do
				printf "  "
				spaces=$((spaces+1))
			done
			if [ $folder = $HIGHLIGHTED_PATH ]; then 
				printf "\033[32m"
			fi
			printf "$dirname\033[0m\n"
			print_tree_from $folder $((depth+1)) $2
		fi
	done
};

tree(){
	if [ $# -eq 0 ]; then
		echo "print all tree from=$CURR_DIR"
		print_tree_from $XPER_ROOT 1 $CURR_DIR
	else
		echo print tree root=$1 from=$CURR_DIR
		print_tree_from $1 1 $CURR_DIR
		printf "\n"
	fi
}

if [ $# -eq 0 ] || [ $1 != "--import" ]; then
	tree $@
fi
