#!/bin/zsh

get_next_max_num(){
	# echo "[find dir=$1]"
	local folders=($(find $1 -type d -d 1))
	local maxnum=0
	# echo "[folders=$folders]"

	for folder in $folders
	do
		local num=$(expr $(echo $folder | sed -E "s/.*([0-9][0-9][0-9]).*/\1/g"))
		# echo curr_$num
		case "$num" in 
			"" | *[!0-9]*) ;;
			*) 
				if [ $num -gt $maxnum ]
				then 
					maxnum=$num
				fi 
			;;
		esac
		# if [[ $num =~ "[0-9]+" ]] && [ $num -gt $maxnum ]
		# then
		# 	maxnum=$num
		# 	# echo updated to maxnum=$maxnum
		# fi
	done

	maxnum="$((maxnum+1))"
	local numlen=${#maxnum}
	while [ $numlen -lt 3 ]
	do
		maxnum=0$maxnum
		numlen=$((numlen+1))
	done
	echo "$maxnum"
};

dirpath_from_dirtag(){
	REAL_PATH=$1
	DIR_TAG=$2
	DIR_PATH=""
	# echo "[real_path=$REAL_PATH]"
	DIRS=($(find $REAL_PATH -type d -d 1))
	# echo "[DIRS=$DIRS]"
	for folder in $DIRS; do
		TAG=$(grep "TAG=" $folder/.meta 2>/dev/null | sed -E "s/TAG=(.*)/\1/g" 2>/dev/null)
		# echo "[found tag=$TAG]"
		if [[ $TAG = $DIR_TAG ]]; then
			DIR_PATH=$folder
			break
		fi
	done
	echo $DIR_PATH
	if [ ${#DIR_PATH} -eq 0 ]; then 
		return 1
	else
		return 0
	fi
};

path_from_tagged_path(){
	TAGGED_PATH=$1
	REAL_PATH=""
	dirtag=""
	firsttime=1
	# echo "[tag_size=${#TAGGED_PATH}]"
	for i in {1..${#TAGGED_PATH}}; do
		if [[ ${TAGGED_PATH[i]} = "/" ]] || [[ $i -eq ${#TAGGED_PATH} ]]; then
			if [[ ${TAGGED_PATH[i]} != "/" ]]; then dirtag+=${TAGGED_PATH[i]}; fi
			# echo "[working with dirtag=$dirtag]"
			if [[ $dirtag != "." ]] && [[ $dirtag != ".." ]]; then
				if [[ $firsttime -eq 1 ]]; then
					# echo "[xper_root=$XPER_ROOT and dirtag=$dirtag]"
					if [[ $(grep "TAG=" $XPER_ROOT/.meta 2>/dev/null | sed -E "s/TAG=(.*)/\1/g" 2>/dev/null) = $dirtag ]]; then 
						REAL_PATH=$XPER_ROOT
					fi
					# REAL_PATH=$(dirpath_from_dirtag $XPER_ROOT $dirtag)
					# echo what we doin $REAL_PATH
				else
					REAL_PATH=$(dirpath_from_dirtag $REAL_PATH $dirtag)
				fi
				if [ $? -eq 1 ]; then echo $REAL_PATH; return 1; fi
			else
				REAL_PATH+="$dirtag/"
			fi
			dirtag=""
			firsttime=0
			# echo "updating [REAL_PATH=$REAL_PATH]"
			continue
		fi
		dirtag+=${TAGGED_PATH[i]}
	done
	echo $REAL_PATH
};
